Subject: bug#63271: 29.0.90; broken mouse-face

From: Po Lu <[email-masked]>
Date: Fri, 12 May 2023 11:19:01 +0800

Eli Zaretskii <[email-masked]> writes:

>> From: Po Lu <[email-masked]>
>> Cc: Gregory Heytings <[email-masked]>,  [email-masked],
>>   [email-masked],  [email-masked]
>> Date: Thu, 11 May 2023 08:51:05 +0800
>> 
>> Eli Zaretskii <[email-masked]> writes:
>> 
>> > Po Lu, was that change intentional?  If not, let's remove that line or
>> > move it under some conditional that doesn't include all Cairo builds.
>> > If it was intentional, please explain why, and let's take it from
>> > there.
>> 
>> It was needed to prevent drawing overhangs as part of the cursor from
>> overwriting surrounding characters with the glyph string background.
>> 
>> Unfortunately, I don't remember why it was needed, though I think the
>> underlying reason has been fixed.
>
> So can we undo that now?  If there is still a reason for doing
> something special there, it will pop up sooner or later, and we can
> deal with it at that time.  At the very least, the setting of
> s->background_filled_p should not be done when s->hl is one of the
> last 3 values in enum draw_glyphs_face, I think, and maybe also when
> s->for_overlaps is zero.
>
> I'd like to fix this soon, because I want to make another pretest of
> 29.1.
>
> Thanks.

Please go ahead and remove it from ftcrfont.c.  The reason it was added
has already been fixed.